import re from "express-graphql";
import { makeExecutableSchema as se } from "@graphql-tools/schema";
import { GraphQLScalarType as oe, GraphQLError as V, GraphQLList as O, GraphQLBoolean as j, GraphQLString as g, GraphQLInt as T, GraphQLFloat as A, GraphQLNonNull as D, GraphQLID as m, GraphQLObjectType as F, GraphQLInputObjectType as B, GraphQLSchema as ce, extendSchema as ie, parse as ae, printSchema as U } from "graphql";
import { camelize as N, singularize as $, pluralize as _ } from "inflection";
import L from "graphql-type-json";
var w;
(function(e) {
  e.NAME = "Name", e.DOCUMENT = "Document", e.OPERATION_DEFINITION = "OperationDefinition", e.VARIABLE_DEFINITION = "VariableDefinition", e.SELECTION_SET = "SelectionSet", e.FIELD = "Field", e.ARGUMENT = "Argument", e.FRAGMENT_SPREAD = "FragmentSpread", e.INLINE_FRAGMENT = "InlineFragment", e.FRAGMENT_DEFINITION = "FragmentDefinition", e.VARIABLE = "Variable", e.INT = "IntValue", e.FLOAT = "FloatValue", e.STRING = "StringValue", e.BOOLEAN = "BooleanValue", e.NULL = "NullValue", e.ENUM = "EnumValue", e.LIST = "ListValue", e.OBJECT = "ObjectValue", e.OBJECT_FIELD = "ObjectField", e.DIRECTIVE = "Directive", e.NAMED_TYPE = "NamedType", e.LIST_TYPE = "ListType", e.NON_NULL_TYPE = "NonNullType", e.SCHEMA_DEFINITION = "SchemaDefinition", e.OPERATION_TYPE_DEFINITION = "OperationTypeDefinition", e.SCALAR_TYPE_DEFINITION = "ScalarTypeDefinition", e.OBJECT_TYPE_DEFINITION = "ObjectTypeDefinition", e.FIELD_DEFINITION = "FieldDefinition", e.INPUT_VALUE_DEFINITION = "InputValueDefinition", e.INTERFACE_TYPE_DEFINITION = "InterfaceTypeDefinition", e.UNION_TYPE_DEFINITION = "UnionTypeDefinition", e.ENUM_TYPE_DEFINITION = "EnumTypeDefinition", e.ENUM_VALUE_DEFINITION = "EnumValueDefinition", e.INPUT_OBJECT_TYPE_DEFINITION = "InputObjectTypeDefinition", e.DIRECTIVE_DEFINITION = "DirectiveDefinition", e.SCHEMA_EXTENSION = "SchemaExtension", e.SCALAR_TYPE_EXTENSION = "ScalarTypeExtension", e.OBJECT_TYPE_EXTENSION = "ObjectTypeExtension", e.INTERFACE_TYPE_EXTENSION = "InterfaceTypeExtension", e.UNION_TYPE_EXTENSION = "UnionTypeExtension", e.ENUM_TYPE_EXTENSION = "EnumTypeExtension", e.INPUT_OBJECT_TYPE_EXTENSION = "InputObjectTypeExtension";
})(w || (w = {}));
const ue = /\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z/, Y = (e) => typeof e != "string" || !ue.test(e) ? !1 : new Date(e).toISOString() === e, M = "Date", J = new oe({
  name: M,
  description: "Date type",
  parseValue(e) {
    return new Date(e);
  },
  serialize(e) {
    return Y(e) ? e : e.toISOString();
  },
  parseLiteral(e) {
    if (e.kind !== w.STRING)
      throw new V(
        `Query error: Can only parse dates strings, got a: ${e.kind}`,
        [e]
      );
    if (isNaN(Date.parse(e.value)))
      throw new V("Query error: not a valid date", [e]);
    return new Date(e.value);
  }
}), pe = (e) => !isNaN(parseFloat(e)) && isFinite(e), x = (e) => e.every(pe), le = (e) => Number.isInteger(e), G = (e) => e.every(le), Ee = (e) => typeof e == "boolean", C = (e) => e.every(Ee), Ie = (e) => typeof e == "string", R = (e) => e.every(Ie), Oe = (e) => Array.isArray(e), Te = (e) => e.every(Oe), ge = (e) => e instanceof Date || Y(e), fe = (e) => e.every(ge), _e = (e) => Object.prototype.toString.call(e) === "[object Object]", Q = (e) => e.every(_e), u = (e, n) => n ? new D(e) : e, X = (e, n = [], t = !1) => {
  if (e === "id" || e.substr(e.length - 3) === "_id")
    return u(m, t);
  if (n.length > 0) {
    if (Te(n)) {
      const r = n.reduce((s, o) => (o.forEach((a) => s.push(a)), s), []);
      return C(r) ? u(
        new O(j),
        t
      ) : R(r) ? u(
        new O(g),
        t
      ) : G(r) ? u(
        new O(T),
        t
      ) : x(r) ? u(
        new O(A),
        t
      ) : Q(r) ? u(L, t) : u(
        new O(g),
        t
      );
    }
    if (C(n))
      return u(j, t);
    if (fe(n))
      return u(J, t);
    if (R(n))
      return u(g, t);
    if (G(n))
      return u(T, t);
    if (x(n))
      return u(A, t);
    if (Q(n))
      return u(L, t);
  }
  return u(g, t);
}, z = (e) => e.reduce((n, t) => (Object.keys(t).forEach((r) => {
  n[r] || (n[r] = []), t[r] != null && n[r].push(t[r]);
}), n), {}), b = (e, n = !0) => {
  const t = z(e), r = e.length;
  return Object.keys(t).reduce((s, o) => (s[o] = {
    type: X(
      o,
      t[o],
      n ? t[o].length === r : !1
    )
  }, s), {});
}, Se = (e) => N(e), S = (e) => N($(e)), ye = (e) => _(e.substr(0, e.length - 3)), Ne = (e) => `${$(e)}_id`, H = (e) => S(e.substr(0, e.length - 3)), De = (e) => Object.keys(e).map((n) => ({
  name: N($(n)),
  fields: b(e[n])
})).map((n) => new F(n)), Fe = (e) => {
  const n = z(e);
  return Object.keys(n).reduce((t, r) => {
    const s = X(
      r,
      n[r],
      !1
    );
    return (s == T || s == A || s.name == g || s.name == M) && (t[`${r}_lt`] = { type: s }, t[`${r}_lte`] = { type: s }, t[`${r}_gt`] = { type: s }, t[`${r}_gte`] = { type: s }), s != j && s != O && (t[`${r}_neq`] = { type: s }), t;
  }, {});
}, W = (e) => Object.keys(e).reduce(
  (n, t) => Object.assign({}, n, {
    [S(t)]: new B({
      name: `${S(t)}Filter`,
      fields: Object.assign(
        {
          q: { type: g }
        },
        {
          ids: { type: new O(m) }
        },
        b(e[t], !1),
        Fe(e[t])
      )
    })
  }),
  {}
), Z = (e) => e.endsWith("_id"), d = (e) => {
  const n = De(e), t = n.reduce((i, c) => (i[c.name] = c, i), {}), r = W(e), s = new F({
    name: "ListMetadata",
    fields: {
      count: { type: T }
    }
  }), o = new F({
    name: "Query",
    fields: n.reduce((i, c) => (i[c.name] = {
      type: t[c.name],
      args: {
        id: { type: new D(m) }
      }
    }, i[`all${N(_(c.name))}`] = {
      type: new O(t[c.name]),
      args: {
        page: { type: T },
        perPage: { type: T },
        sortField: { type: g },
        sortOrder: { type: g },
        filter: { type: r[c.name] }
      }
    }, i[`_all${N(_(c.name))}Meta`] = {
      type: s,
      args: {
        page: { type: T },
        perPage: { type: T },
        filter: { type: r[c.name] }
      }
    }, i), {})
  }), a = new F({
    name: "Mutation",
    fields: n.reduce((i, c) => {
      const l = t[c.name].getFields(), y = Object.keys(l).reduce(
        (f, I) => (f[I] = Object.assign({}, l[I], {
          type: I !== "id" && l[I].type instanceof D ? l[I].type.ofType : l[I].type
        }), f),
        {}
      ), { id: P, ...h } = l, te = Object.keys(h).reduce(
        (f, I) => (f[I] = Object.assign({}, h[I]), delete f[I].resolve, f),
        {}
      ), ne = new B({
        name: c.name + "Input",
        fields: te
      });
      return i[`create${c.name}`] = {
        type: t[c.name],
        args: h
      }, i[`createMany${c.name}`] = {
        type: new O(t[c.name]),
        args: {
          data: {
            type: new O(ne)
          }
        }
      }, i[`update${c.name}`] = {
        type: t[c.name],
        args: y
      }, i[`remove${c.name}`] = {
        type: t[c.name],
        args: {
          id: { type: new D(m) }
        }
      }, i;
    }, {})
  }), p = new ce({
    query: o,
    mutation: a
  }), E = Object.values(t).reduce((i, c) => (Object.keys(c.getFields()).filter(Z).map((l) => {
    const y = H(l), P = _(c.toString());
    i += `
extend type ${c} { ${y}: ${y} }
extend type ${y} { ${P}: [${c}] }`;
  }), i), "");
  return E ? ie(p, ae(E)) : p;
}, q = (e = [], n = {}) => {
  let t = [...e];
  return n.ids ? t = t.filter((r) => n.ids.some((s) => s == r.id)) : (Object.keys(n).filter((r) => r !== "q").forEach((r) => {
    if (r.indexOf("_neq") !== -1) {
      const s = r.replace(/(_neq)$/, "");
      t = t.filter((o) => n[r] instanceof Date && typeof o[s] == "string" ? o[s] != n[r].toISOString() : o[s] != n[r]);
      return;
    }
    if (r.indexOf("_lte") !== -1) {
      const s = r.replace(/(_lte)$/, "");
      t = t.filter((o) => n[r] instanceof Date && typeof o[s] == "string" ? o[s] <= n[r].toISOString() : o[s] <= n[r]);
      return;
    }
    if (r.indexOf("_gte") !== -1) {
      const s = r.replace(/(_gte)$/, "");
      t = t.filter((o) => n[r] instanceof Date && typeof o[s] == "string" ? o[s] >= n[r].toISOString() : o[s] >= n[r]);
      return;
    }
    if (r.indexOf("_lt") !== -1) {
      const s = r.replace(/(_lt)$/, "");
      t = t.filter((o) => n[r] instanceof Date && typeof o[s] == "string" ? o[s] < n[r].toISOString() : o[s] < n[r]);
      return;
    }
    if (r.indexOf("_gt") !== -1) {
      const s = r.replace(/(_gt)$/, "");
      t = t.filter((o) => n[r] instanceof Date && typeof o[s] == "string" ? o[s] > n[r].toISOString() : o[s] > n[r]);
      return;
    }
    Array.isArray(n[r]) ? t = t.filter((s) => Array.isArray(s[r]) ? n[r].every(
      (o) => s[r].some((a) => o instanceof Date && typeof a == "string" ? a == o.toISOString() : a == o)
    ) : n[r].filter((o) => o instanceof Date && typeof s[r] == "string" ? s[r] == o.toISOString() : o == s[r]).length > 0) : t = t.filter((s) => n[r] instanceof Date && typeof s[r] == "string" ? s[r] == n[r].toISOString() : n[r] instanceof Date ? +s[r] == +n[r] : s[r] == n[r]);
  }), n.q && (t = t.filter(
    (r) => Object.keys(r).some(
      (s) => r[s] && r[s].toString().toLowerCase().includes(n.q.toLowerCase())
    )
  ))), t;
}, me = (e = []) => (n, { sortField: t, sortOrder: r = "asc", page: s, perPage: o = 25, filter: a = {} }) => {
  let p = [...e];
  if (t) {
    const E = r.toLowerCase() == "asc" ? 1 : -1;
    p = p.sort((i, c) => i[t] > c[t] ? E : i[t] < c[t] ? -1 * E : 0);
  }
  return p = q(p, a), s !== void 0 && o && (p = p.slice(s * o, s * o + o)), p;
}, be = (e) => (n, { filter: t = {} }) => ({ count: q(e, t).length }), he = (e = []) => (n, { id: t }) => e.find((r) => r.id == t), k = (e = []) => (n, t) => {
  const r = e.length > 0 ? e[e.length - 1].id + 1 : 0, s = Object.assign({}, t, { id: r });
  return e.push(s), s;
}, je = (e = []) => (n, t) => t.data.map((r) => k(e)(null, r)), Ae = (e = []) => (n, t) => {
  let r;
  if (t.id != null) {
    const s = t.id.toString(), o = e.findIndex(
      (a) => a.id != null && a.id.toString() === s
    );
    o !== -1 && (e[o] = Object.assign(
      {},
      e[o],
      t
    ), r = e[o]);
  }
  return r;
}, Le = (e = []) => (n, { id: t }) => {
  let r;
  if (t != null) {
    const s = t.toString(), o = e.findIndex(
      (a) => a.id != null && a.id.toString() === s
    );
    o !== -1 && (r = e.splice(o, 1)[0]);
  }
  return r;
}, we = (e, n) => {
  const r = Object.keys(b(n[e])).filter(Z).reduce(
    (E, i) => Object.assign({}, E, {
      [H(i)]: (c) => n[ye(i)].find(
        (l) => l.id == c[i]
      )
    }),
    {}
  ), s = Ne(e), o = (E) => Object.keys(b(n[E])).includes(
    s
  ), p = Object.keys(n).filter(o).reduce(
    (E, i) => Object.assign({}, E, {
      [Se(i)]: (c) => n[i].filter(
        (l) => l[s] == c.id
      )
    }),
    {}
  );
  return Object.assign({}, r, p);
}, v = (e, n) => Object.values(W(n)).reduce((t, r) => t ? !0 : Object.values(r.getFields()).reduce((s, o) => s ? !0 : o.type.name == e, !1), !1), $e = (e, n) => ({
  [`all${_(e)}`]: me(n),
  [`_all${_(e)}Meta`]: be(n),
  [e]: he(n)
}), Me = (e, n) => ({
  [`create${e}`]: k(n),
  [`createMany${e}`]: je(n),
  [`update${e}`]: Ae(n),
  [`remove${e}`]: Le(n)
}), K = (e) => Object.assign(
  {},
  {
    Query: Object.keys(e).reduce(
      (n, t) => Object.assign(
        {},
        n,
        $e(S(t), e[t])
      ),
      {}
    ),
    Mutation: Object.keys(e).reduce(
      (n, t) => Object.assign(
        {},
        n,
        Me(S(t), e[t])
      ),
      {}
    )
  },
  Object.keys(e).reduce(
    (n, t) => Object.assign({}, n, {
      [S(t)]: we(t, e)
    }),
    {}
  ),
  v(M, e) ? { Date: J } : {},
  // required because makeExecutableSchema strips resolvers from typeDefs
  v("JSON", e) ? { JSON: L } : {}
  // required because makeExecutableSchema strips resolvers from typeDefs
), ee = (e) => se({
  typeDefs: U(d(e)),
  resolvers: K(e),
  logger: { log: (n) => console.log(n) }
  // eslint-disable-line no-console
}), Re = (e) => ({
  typeDefs: U(d(e)),
  resolvers: K(e)
}), Qe = (e) => re({
  schema: ee(e),
  graphiql: !0
}), ve = ee;
export {
  Qe as default,
  Re as getPlainSchema,
  ve as jsonSchemaBuilder
};
//# sourceMappingURL=json-graphql-server-node.js.map
